'use strict';
import React from 'react'
import { connect }  from 'react-redux';

import {getStoreInfo} from "../../actions/getStore";
import {getTroubleList} from "../../actions/getTroubles";
import {intGetOtherProblem} from "../../actions/otherQuestion"

import HeaderComponent from '../../components/CommonComponent/HeaderComponent/HeaderComponent'
import PopupComponent from '../../components/CommonComponent/PopupComponent/PopupComponent'
import TroubleContainer from '../TroubleContainer/TroubleContainer'
import TextAreaContainer from '../TextAreaContainer/TextAreaContainer'
import ScanBarCodeContainer from '../ScanBarCodeContainer/ScanBarCodeContaienr'
import ReportDamagesListContainer from '../ReportDamagesListContainer/ReportDamagesListContainer'
import OtherQuestionContainer from '../OtherQuestionContainer/OtherQuestionContainer'
import HomeContainer from '../HomeContainer/HomeContainer'
import FinishAskContainer from '../FinishAskContainer/FinishAskContainer'
import ChooseTaskContainer from '../ChooseTaskContainer/ChooseTaskContainer'
import Qrcode from '../Qrcode/Qrcode'

require('./index.css')

const showPage = {
    1 : 'Trouble',
    2 : 'Scan',
    3 : 'DamageProductList',
    4 : 'OtherQuestionUpload',
    5 : 'TextArea',
    6 : 'Qrcode',
    7 : 'Home',
    8 : 'FinishAsk',
    9 : 'ChooseTask'
}


const defaultPopupInfo = {
        showPopup : false, //是否显示弹窗
        popupChild : null, // 自定义弹窗内部htmls
        popupText : "", //默认弹窗的文本 （必填）
        popupButtons : [], // 默认弹窗的按钮
        classNames : '' //自定义类名
    };

class PageContainer extends React.Component {
    constructor(props) {
        super(props);
        // UTILPATH.socket.getIp();
        this.state = {
            showPage : showPage[4],
            page : null,
            popupInfo : defaultPopupInfo,
            pageStyle : {
                // 'backgroundColor' : '#ffffff'
            }
        };
        this.getPages = this.getPages.bind(this);
        this.showPopup = this.showPopup.bind(this);
        this.hidePopup = this.hidePopup.bind(this);
    }
    componentWillMount() {
        let {dispatch} = this.props;
        dispatch(getStoreInfo());
        dispatch(getTroubleList());
        let pages = this.getPages();
        this.setState({
            page : pages
        })
    }
    componentDidMount(){
    }
    componentDidUpdate() {
    }
    componentWillReceiveProps(nextProps){
    }
    componentWillUnmount(){
    }

    hidePopup(){
        this.setState({
            popupInfo : defaultPopupInfo
        })
    }
    showPopup(info){
        //eg : info = {popupText:'test',popupButtons:[{text : '返回',option:FUNCTION}]}
        let popupInfo = Object.assign({},defaultPopupInfo,info);
        if(
            (   popupInfo.popupChild ||
                popupInfo.popupText ||
                (popupInfo.popupButtons && popupInfo.popupButtons.length > 0)
            ) && !popupInfo.showPopup
        ){
            popupInfo.showPopup = true; //以防未设置显示弹窗，做此判断。
        }

        this.setState({
            popupInfo : popupInfo,
        })
    }

    getPages(){
        let pages = null;
        let{state,dispatch} = this.props;
        switch (this.state.showPage){
            case showPage[1]:
                pages = <TroubleContainer />;
                break;
            case showPage[2]:
                pages = <ScanBarCodeContainer />;
                break;
            case showPage[3]:
                pages = <ReportDamagesListContainer />;
                break;
            case showPage[4]:
                pages = <OtherQuestionContainer
                            initStart = {(postData)=>dispatch(intGetOtherProblem(postData))}
                                state = {state}
                        />;
                break;
            case showPage[5]:
                pages = <TextAreaContainer />;
                break;
            case showPage[6]:
                pages = <Qrcode />;
                break;
            case showPage[7]:
                pages = <HomeContainer />;
                break;
            case showPage[8]:
                pages = <FinishAskContainer />;
                break;
            case showPage[9]:
                pages = <ChooseTaskContainer />;
                break;
        }
        return pages;
    }

    render() {
        return (
            <div className={"pageContainer "} style={this.state.pageStyle}>
                <HeaderComponent />
                <PopupComponent popupInfo={this.state.popupInfo} />
                {this.getPages()}
            </div>
        )
    }
}

function select(store) {
    return Object.assign({}, {state: store})
}

export default connect(select)(PageContainer)